/*
 * TMCL-Defines.h
 *
 *  Created on: 17.08.2011
 *      Author: ed (based on work of OK)
 */

#ifndef TMCL_DEFINES_H_
#define TMCL_DEFINES_H_

	#include "Definitions.h"

	#define TMCL_RAM_USER_VARS 256     //Es gibt 256 User-Variablen (mehr als 256 geht nicht)...
	#define TMCL_EEPROM_USER_VARS 56   //...von denen die ersten 56 auch im EEPROM gespeichert werden knnen.

	// interpreter states
	#define TM_IDLE 0
	#define TM_RUN 1
	#define TM_STEP 2
	#define TM_RESET 3   //nicht verwendet
	#define TM_DOWNLOAD 4
	#define TM_DEBUG 5  //wie TM_IDLE, es wird jedoch der Akku nicht modifiziert bei GAP etc.

	#define TCS_IDLE  0
	#define TCS_CAN7  1
	#define TCS_CAN8  2
	#define TCS_UART  3
	#define TCS_UART_ERROR 4
	#define TCS_UART_II 5
	#define TCS_UART_II_ERROR 6
	#define TCS_USB   7
	#define TCS_USB_ERROR 8
	#define TCS_MEM   9

	// TMCL commands
	#define TMCL_ROR 1
	#define TMCL_ROL 2
	#define TMCL_MST 3
	#define TMCL_MVP 4
	#define TMCL_SAP 5
	#define TMCL_GAP 6
	#define TMCL_STAP 7
	#define TMCL_RSAP 8
	#define TMCL_SGP 9
	#define TMCL_GGP 10
	#define TMCL_STGP 11
	#define TMCL_RSGP 12
	#define TMCL_RFS 13
	#define TMCL_SIO 14
	#define TMCL_GIO 15
	#define TMCL_CALC 19
	#define TMCL_COMP 20
	#define TMCL_JC   21
	#define TMCL_JA   22
	#define TMCL_CSUB 23
	#define TMCL_RSUB 24
	#define TMCL_WAIT 27
	#define TMCL_STOP 28
	#define TMCL_SAC 29
	#define TMCL_SCO 30
	#define TMCL_GCO 31
	#define TMCL_CCO 32
	#define TMCL_CALCX 33
	#define TMCL_AAP 34
	#define TMCL_AGP 35
	#define TMCL_CLE 36
	#define TMCL_VECT 37
	#define TMCL_RETI 38
	#define TMCL_ACO 39
	#define TMCL_UF0 64
	#define TMCL_UF1 65
	#define TMCL_UF2 66
	#define TMCL_UF3 67
	#define TMCL_UF4 68
	#define TMCL_UF5 69
	#define TMCL_UF6 70
	#define TMCL_UF7 71

	#define TMCL_ApplStop 128
	#define TMCL_ApplRun 129
	#define TMCL_ApplStep 130
	#define TMCL_ApplReset 131
	#define TMCL_DownloadStart 132
	#define TMCL_DownloadEnd 133
	#define TMCL_ReadMem 134
	#define TMCL_GetStatus 135
	#define TMCL_GetVersion 136
	#define TMCL_FactoryDefault 137
	#define TMCL_SetEvent 138
	#define TMCL_SetASCII 139
	#define TMCL_SecurityCode 140
	#define TMCL_Breakpoint 141

	#define TMCL_Boot 0xf2
	#define TMCL_SoftwareReset 0xff

	#define MVP_ABS 0
	#define MVP_REL 1
	#define MVP_COORD 2
	#define MVP_RELCOORD 3

	#define RFS_START 0
	#define RFS_STOP 1
	#define RFS_STATUS 2

	#define WAIT_TICKS 0
	#define WAIT_POS 1
	#define WAIT_REFSW 2
	#define WAIT_LIMSW 3
	#define WAIT_RFS 4

	#define CLE_ALL 0
	#define CLE_ETO 1
	#define CLE_EAL 2
	#define CLE_EDV 3
	#define CLE_EPO 4
	#define CLE_ESD 5

	// status codes
	#define REPLY_OK 100
	#define REPLY_CMD_LOADED 101
	#define REPLY_CHKERR 1
	#define REPLY_INVALID_CMD 2
	#define REPLY_WRONG_TYPE 3
	#define REPLY_INVALID_VALUE 4
	#define REPLY_EEPROM_LOCKED 5
	#define REPLY_CMD_NOT_AVAILABLE 6
	#define REPLY_CMD_LOAD_ERROR 7
	#define REPLY_WRITE_PROTECTED 8
	#define REPLY_MAX_EXCEEDED 9
	#define REPLY_DELAYED 128
	#define REPLY_ACTIVE_COMM 129

	// reply format
	#define RF_STANDARD 0
	#define RF_SPECIAL 1

	// write/read protection bits
	#define PB_READ  0x01
	#define PB_WRITE 0x02

	// TMCL request command
	typedef struct
	{
		UCHAR Opcode;
		UCHAR Type;
		UCHAR Motor;
		union
		{
			int Int32;
			UCHAR Byte[4];
		} Value;
	} TTMCLCommand;

	// TMCL reply command
	typedef struct
	{
		UCHAR Status;
		UCHAR Opcode;
		union
		{
			int Int32;
			UCHAR Byte[4];
		} Value;
	} TTMCLReply;

#endif /* TMCL_DEFINES_H_ */
